using System;
using System.Text.Json.Serialization;
namespace org.accordproject.cicero.runtime {
   using org.accordproject.cicero.contract;
   using org.accordproject.money;
   using concerto;
   class Request : Transaction {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.accordproject.cicero.runtime.Request";
   }
   class Response : Transaction {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.accordproject.cicero.runtime.Response";
   }
   abstract class ErrorResponse : Transaction {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.accordproject.cicero.runtime.ErrorResponse";
   }
   abstract class Obligation : Event {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.accordproject.cicero.runtime.Obligation";
      public AccordContract contract { get; set; }
      public Participant promisor { get; set; }
      public Participant promisee { get; set; }
      public DateTime deadline { get; set; }
   }
   class PaymentObligation : Obligation {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.accordproject.cicero.runtime.PaymentObligation";
      public MonetaryAmount amount { get; set; }
      public string description { get; set; }
   }
   class NotificationObligation : Obligation {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.accordproject.cicero.runtime.NotificationObligation";
      public string title { get; set; }
      public string message { get; set; }
   }
   class Payload : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.accordproject.cicero.runtime.Payload";
      public AccordContract contract { get; set; }
      public Request request { get; set; }
      public AccordContractState state { get; set; }
   }
   class Success : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.accordproject.cicero.runtime.Success";
      public Response response { get; set; }
      public AccordContractState state { get; set; }
      public Event[] emit { get; set; }
   }
   class Failure : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.accordproject.cicero.runtime.Failure";
      public ErrorResponse error { get; set; }
   }
}
